/*
 * * * Compile_AHK SETTINGS BEGIN * * *

[AHK2EXE]
Exe_File=%In_Dir%\rcopy_slave_x64.exe
Alt_Bin=C:\Program Files\AutoHotkey\Compiler\Unicode 64-bit.bin
No_UPX=1

* * * Compile_AHK SETTINGS END * * *
*/

#NoTrayIcon
#include MilesAhead.ahk
FileTotalWarning := 128
OverWrite := 1
switch := ""
version := ""

if A_IsCompiled
  FileGetVersion,version, %A_ScriptFullPath%
if !version
  version := "1.0.0.4"

UsageMsg = 
(
rcopy v. %version%  copyright 2012  www.favessoft.com`n
Usage: rcopy [/n] FilePattern DestFolder ( /n = No overwrite dest files )`n
recursively copies files FilePattern from working directory to DestFolder
( Destination must exist : Only files are copied. Not Folder Structure. )`n
If FilePattern includes a valid path, it will be set as working directory`n
  example 1: rcopy *.srt c:\temp
  example 2: rcopy c:\subtitles\*.srt c:\temp
  example 3: rcopy /n c:\docs\*.doc d:\tempdocs`n
  Target may be in working directory tree. If the path of the source
  file is the same as the target, it will be skipped.`n
  This is a command line alternative to searching in Explorer,
  then dragging to copy the results to a target folder.`n
      Donate ??
)

if 0 < 2
{
  MsgBox, 4388, rcopy, %UsageMsg%
  IfMsgBox, Yes
    Run, http://www.favessoft.com/donate.html
  Exit
}

FilePat = %1%
DestFold = %2%
if 0 > 2
{
  DestFold = %3%
  FilePat = %2%
  switch = %1%
  if (switch = "/n")
    OverWrite := 0
}
SaveDestFold := DestFold
DestFold := AbsolutePath(DestFold)
DestFold := _FileDir(DestFold)
if !_DirExist(DestFold)
{
  err := SaveDestFold . " Folder does not exist!"
  _ErrorMessage(err,"rcopy")
}

WDir := _FileDir(FilePat)
if WDir
{
  if !_DirExist(WDir)
    _ErrorMessage(WDir . " is Not A Valid Path","rcopy")
  SetWorkingDir,%WDir%
  if ErrorLevel
    _ErrorMessage("Error Changing Working Directory to: " . WDir,"rcopy")
  FilePat := _FileName(FilePat)
}

FileCount := _TotalFileCount()
if ( FileCount > FileTotalWarning)
{
  MsgBox, 4388, rcopy, Up to %FileCount% Files may be copied.  Continue??
  IfMsgBox, No
    Exit
}
CopyCount := 0

Loop, %FilePat%,,1
{
  if ( _FileDir(A_LoopFileLongPath) = DestFold )
    continue
  if A_LoopFileAttrib contains H,R,S
      continue
  FileCopy, %A_LoopFileLongPath%, %DestFold%, %OverWrite%
  if !ErrorLevel
    CopyCount += 1
}
Exit,%CopyCount%

_TotalFileCount()
{
  global FilePat
  global DestFold
  file_count := 0
  Loop, %FilePat%,,1
  {
    if ( _FileDir(A_LoopFileLongPath) = DestFold )
    continue
    if A_LoopFileAttrib contains H,R,S
      continue
    file_count += 1
  }
  return file_count
}
